//
//  AppDelegate.swift
//  TSSmalCoacopods
//
//  Created by MG.Max on 02/07/2025.
//  Copyright (c) 2025 MG.Max. All rights reserved.
//

import UIKit

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?


    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
        SVProgressHUD.swizzleMethods()
        return true
    }

    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}



import Foundation
import ObjectiveC
import SVProgressHUD
extension SVProgressHUD {
    // 重写 moveToPoint:rotateAngle: 方法
    @objc dynamic func swizzledMoveToPoint(_ newCenter: CGPoint, rotateAngle angle: CGFloat) {
        // 调用原方法
        self.swizzledMoveToPoint(newCenter, rotateAngle: angle)
        
        // 使用运行时获取 hudView 属性
        if let hudView = getHudView() {
            if let containerView = containerView {
                hudView.center = CGPoint(x: containerView.bounds.size.width/2 + offsetFromCenter.horizontal, y: containerView.bounds.size.height/2 + offsetFromCenter.vertical)
            } else {
                hudView.center = CGPoint(x: newCenter.x + offsetFromCenter.horizontal, y: newCenter.y + offsetFromCenter.vertical)
            }
        }
    }
    
    // 获取 hudView 属性
    private func getHudView() -> UIVisualEffectView? {
        var count: UInt32 = 0
        guard let classProperties = class_copyPropertyList(SVProgressHUD.self, &count) else {
            return nil
        }
        
        for i in 0..<Int(count) {
            let property = classProperties[i]
            let propertyName = String(cString: property_getName(property))
            if propertyName == "hudView" {
                let hudView = value(forKey: propertyName) as? UIVisualEffectView
                free(classProperties)
                return hudView
            }
        }
        
        free(classProperties)
        return nil
    }
}

// 方法交换
extension SVProgressHUD {
    static func swizzleMethods() {
        // 手动创建选择器
        let originalSelector = NSSelectorFromString("moveToPoint:rotateAngle:")
        let swizzledSelector = #selector(SVProgressHUD.swizzledMoveToPoint(_:rotateAngle:))
        
        let originalMethod = class_getInstanceMethod(SVProgressHUD.self, originalSelector)
        let swizzledMethod = class_getInstanceMethod(SVProgressHUD.self, swizzledSelector)
        
        if let originalMethod = originalMethod, let swizzledMethod = swizzledMethod {
            method_exchangeImplementations(originalMethod, swizzledMethod)
        }
    }
}
